//
// dockapp.hh for pekwm
// Copyright (C) 2003-2004 Claes Nasten <pekdon{@}pekdon{.}net>
//
// This program is licensed under the GNU GPL.
// See the LICENSE file for more information.
//

#include "../config.h"

#ifdef HARBOUR

#ifndef _DOCKAPP_HH_
#define _DOCKAPP_HH_

#include "pekwm.hh"
#include "AutoProperties.hh"

class PScreen;
class Theme;
class PWinObj;

class DockApp : public PWinObj
{
public:
	DockApp(PScreen *scr, Theme *theme, Window win);
	~DockApp(void);

	// START - PWinObj interface.
	virtual void mapWindow(void);
	virtual void unmapWindow(void);
	// END - PWinObj interface.

	inline uint getClientWidth(void) const { return _c_gm.width; }
	inline uint getClientHeight(void) const { return _c_gm.height; }
	inline int getPosition(void) const { return _position; }
	inline void setAlive(bool alive) { _is_alive = alive; }
	inline void setLayer(Layer layer) { _layer = layer; }

	inline bool findDockApp(Window win) {
		if ((win != None) &&
				(win == _client_window) || (win == _icon_window))
			return true;
		return false;
	}
	inline bool findDockAppFromFrame(Window win) {
		if ((win != None) && (win == _window))
			return true;
		return false;
	}

	void kill(void);
	void move(int x, int y);
	void resize(uint width, uint height);

	void loadTheme(void);

private:
	void repaint(void);

	void updateSize(void);
	void validateSize(void);

	void readClassHint();
	void readAutoProperties();

private:
	PScreen *_scr;
	Theme *_theme;

	Window _dockapp_window;
	Window _client_window, _icon_window;

	ClassHint _class_hint;

	Geometry _c_gm;
	int _position; // used in sorted mode

	Pixmap _background;

	bool _is_alive;
};

#endif // _DOCKAPP_HH_

#endif // HARBOUR
