//
// ImageHandler.hh for pekwm
// Copyright (C)  2003-2004 Claes Nasten <pekdon{@}pekdon{.}net>
//
// This program is licensed under the GNU GPL.
// See the LICENSE file for more information.
//

#include "../config.h"

#ifndef _IMAGE_HANDLER_HH_
#define _IMAGE_HANDLER_HH_

#include "Handler.hh"
#include "ParseUtil.hh"

#include <string>
#include <list>

class Image;

class ImageHandler {
public:
	ImageHandler(void);
	~ImageHandler(void);

	static inline ImageHandler *instance(void) { return _instance; }

	inline void setDir(const std::string &dir) { _dir = dir; }

	Image *getImage(const std::string &file);
	void returnImage(Image *image);

	void freeUnref(void);

private:
	std::string _dir;

	std::list<HandlerEntry<Image*> > _image_list;

	bool _free_on_return;

	std::map<const ParseUtil::Entry, ImageType> _image_type_map;

	static ImageHandler *_instance;
};

#endif // _IMAGE_HANDLER_HH_
